#!/bin/bash

## This is a generic example of the type of script file used on the Production and Development PakVM servers 

if [ $# -lt 1 ]
  then
      echo "There is ONE (1) REQUIRED Parameter :"
      echo " {ETHERNET device name} = Name of the system hardware device to use "
      echo ""
      echo " fe: $0 hostint  - will create a macvtap device for this machine as a bridge off of hostint "
      exit 1
fi

mactap="VM01prod-eth0"
srvnet="$1"

## START

# Create the tap and bring it up
/sbin/ip link add link ${srvnet} name ${mactap} type macvtap mode bridge
/sbin/ip link set ${mactap} up

# Get the MAC address 
tapaddr="$(cat /sys/class/net/${mactap}/address)"
##  NOTE - IF instead this machine REQUIRES we set the MAC address then rem out the above line and use the following
# tapaddr="00:50:56:00:01:0a"
# /sbin/ip link set dev ${mactap} address ${tapaddr}

# Get the TAP device
tapdev=$(cat /sys/class/net/${mactap}/ta*/uevent | grep DEVNAME | cut -d= -f2)

# NOW run the qemu - NOTE the Monitor excape key is = C-f (ascii 6) as stated in the -echr below...

## EXAMPLE with TWO network interfaces - need more info above... - SEE PIC
# /opt/PakVM/bin/qemu-system-x86_64 -enable-kvm -m 1024 -drive format=raw,file=VMfromesxi-02jul20-flat.vmdk -device virtio-net-pci,mac=${tapaddr},netdev=inet01 -netdev tap,id=inet01,fd=9 9<>/dev/${tapdev} -device virtio-net-pci,mac=${sysmac},netdev=pakvm01 -netdev tap,id=pakvm01,ifname=${sysname},script=no,downscript=no -echr 10 -nographic -serial mon:stdio -monitor unix:/opt/PakVM/MONSOCK/pakvm01spice.sock,server,nowait -name PakVM01-Spice -spice port=7110,password=pakvm

## Generic image run using single interface
/opt/PakVM/bin/qemu-system-x86_64 -enable-kvm -m 1024 -drive format=raw,file=VMfromesxi-02jul20-flat.vmdk -device virtio-net-pci,mac=${tapaddr},netdev=inet01 -netdev tap,id=inet01,fd=9 9<>/dev/${tapdev} -echr 10 -nographic -serial mon:stdio -monitor unix:/opt/PakVM/MONSOCK/pakvm01spice.sock,server,nowait -name PakVM01-Spice -spice port=7110,password=pakvm

## WIN10 image...
# /opt/PakVM/bin/qemu-system-x86_64 -enable-kvm -m 16384 -cpu host,hv_relaxed,hv_spinlocks=0x1fff,hv_vapic,hv_time -smp 2 -drive index=0,format=raw,file=VMfromesxi-02jul20-flat.vmdk -drive index=1,format=raw,file=DATA-22dec20-flat.vmdk -vga qxl -device virtio-serial-pci -device virtserialport,chardev=spicechannel10,name=com.redhat.spice.0 -chardev spicevmc,id=spicechannel10,name=vdagent -net nic,model=e1000e,macaddr=${tapaddr} -net tap,fd=9 9<>/dev/${tapdev} -echr 6 -nographic -serial mon:stdio -monitor unix:/opt/PakVM/MONSOCK/win10spice.sock,server,nowait -name Win10-Spice -spice port=7000,password=win10


# ECHO for the all done stuff...
echo "ALL DONE -  MAC = ${tapaddr} running on tap = ${tapdev}  for interface ${mactap} cloned from ${srvnet} "
echo "Time to clean up"

# and destroy for now
/sbin/ip link de ${mactap}
