#!/bin/bash

# Global config
LOCNET="192.168.2.0/24"
LOCNETIP="192.168.2.254"
SSTUNNET="172.17.2.0/24"

### Local SS-IPSec configurations
SSVC_HIGH=1
SSENAB=1

# PakVPN SS Tunnel 00 - DCFW01

SSENAB0="1"
SSPAKFW0="1"
SSTUN0="pcfw2dc1"
SSTUNIP0="172.17.2.254"
SS0="pcfw-dc1"
SSLOC0="pak2"
SSINET0="inet"
SSTLOC0="7.6.5.4"
SSTREM0="6.7.8.9"
SSREMRT0="10.1.1.0/24"
SSLOCRT0="192.168.2.0/24
	  192.168.23.0/24"

## Global Variables

case "$1" in
  start)
      ## GLOBAL Start StrongSwan daemons
      /usr/sbin/ipsec start
      /bin/sleep 5
      /usr/sbin/swanctl --load-all
      /bin/sleep 5

      # Initiate TUN
      num=0
      while [ $num -lt $SSVC_HIGH ]; do
	  tunname=`eval echo -n '$SSTUN'$num`
	  loctunip=`eval echo -n '$SSTUNIP'$num`
	  ssctlname=`eval echo -n '$SS'$num`
	  remoteip=`eval echo -n '$SSTREM'$num`
	  localip=`eval echo -n '$SSTLOC'$num`	  
	  remoteroutes=`eval echo -n '$SSREMRT'$num`
	  locint=`eval echo -n '$SSLOC'$num`
  	  inetint=`eval echo -n '$SSINET'$num`

	  /sbin/ip tunnel add ${tunname} mode ipip remote ${remoteip} pmtudisc
	  /sbin/ip addr add ${loctunip} dev ${tunname}
	  /sbin/ip link set dev ${tunname} up
	  /bin/sleep 5

	  itis=`/sbin/iptables -L FORWARD -n -v --line-numbers | grep "${tunname^^}" | /usr/bin/cut -c1 | /usr/bin/tail -1  `
	  if [ -z ${itis} ]; then    
	      forlog=`/sbin/iptables -L FORWARD -n -v --line-numbers | grep "LOG" | /usr/bin/cut -d" " -f1 | /usr/bin/tail -1  `
	      /sbin/iptables -F ${tunname^^}
	      /sbin/iptables -X ${tunname^^}
	      /sbin/iptables -N ${tunname^^}
	      /sbin/iptables -I FORWARD ${forlog} -i ${tunname} -j ${tunname^^}
	      /sbin/iptables -I FORWARD ${forlog} -o ${tunname} -j ${tunname^^}
	  fi

	  for REMADDR in ${remoteroutes}; do
	      /sbin/ip route add ${REMADDR} dev ${tunname} src ${loctunip} protocol static mtu 1435
	      /sbin/ip route flush cache
	      /sbin/iptables -A ${tunname^^} -i ${locint} -o ${tunname} -s ${LOCRT} -d ${REMADDR} -j ACCEPT
	      /sbin/iptables -A ${tunname^^} -o ${locint} -i ${tunname} -d ${LOCRT} -s ${REMADDR} -j ACCEPT
	  done

	  ## Allow IPSEC
	  /sbin/iptables -I INPUT 4 -p 4 -i ${inetint} -s ${remoteip} -d ${localip} -j ACCEPT
	  /sbin/iptables -I INPUT 4 -p 51 -i ${inetint} -s ${remoteip} -d ${localip} -j ACCEPT
	  /sbin/iptables -I INPUT 4 -p 50 -i ${inetint} -s ${remoteip} -d ${localip} -j ACCEPT
	  /sbin/iptables -I INPUT 4 -p udp -i ${inetint} -s ${remoteip} --sport 4500 -d ${localip} --dport 4500 -j ACCEPT
	  /sbin/iptables -I INPUT 4 -p udp -i ${inetint} -s ${remoteip} --sport 500 -d ${localip} --dport 500 -j ACCEPT
	  /sbin/iptables -I OUTPUT 4 -p 4 -o ${inetint} -d ${remoteip} -s ${localip} -j ACCEPT
	  /sbin/iptables -I OUTPUT 4 -p 51 -o ${inetint} -d ${remoteip} -s ${localip} -j ACCEPT
	  /sbin/iptables -I OUTPUT 4 -p 50 -o ${inetint} -d ${remoteip} -s ${localip} -j ACCEPT
	  /sbin/iptables -I OUTPUT 4 -p udp -o ${inetint} -d ${remoteip} --dport 4500 -s ${localip} --sport 4500 -j ACCEPT
	  /sbin/iptables -I OUTPUT 4 -p udp -o ${inetint} -d ${remoteip} --dport 500 -s ${localip} --sport 500 -j ACCEPT

	  ## Start Strongswan... For now just the CHILD...
	  /usr/sbin/swanctl -i -c ${ssctlname}
	  /bin/sleep 5
	  #
	  
	  num=$((num+=1))
      done
      ;;
  stop)
      num=0
      while [ $num -lt $SSVC_HIGH ]; do
	  tunname=`eval echo -n '$SSTUN'$num`
	  loctunip=`eval echo -n '$SSTUNIP'$num`
	  ssctlname=`eval echo -n '$SS'$num`
	  remoteip=`eval echo -n '$SSTREM'$num`
	  localip=`eval echo -n '$SSTLOC'$num`	  
	  remoteroutes=`eval echo -n '$SSREMRT'$num`
	  locint=`eval echo -n '$SSLOC'$num`
  	  inetint=`eval echo -n '$SSINET'$num`

	  ## Kill Strongswan... for now just terminate child
	  /usr/sbin/swanctl -t -c ${ssctlname}
	  	  
	  for REMADDR in ${remoteroutes}; do
	      /sbin/ip route del ${REMADDR} dev ${tunname} src ${loctunip} protocol static mtu 1435
	      /sbin/iptables -D ${tunname^^} -i ${locint} -o ${tunname} -s ${LOCRT} -d ${REMADDR} -j ACCEPT
	      /sbin/iptables -D ${tunname^^} -o ${locint} -i ${tunname} -d ${LOCRT} -s ${REMADDR} -j ACCEPT
	  done
	  /sbin/iptables -F ${tunname^^}
	  /sbin/iptables -X ${tunname^^}
	  /sbin/iptables -D FORWARD -i ${tunname} -j ${tunname^^}
	  /sbin/iptables -D FORWARD -o ${tunname} -j ${tunname^^}

	  /sbin/iptables -D INPUT  -p 4 -i ${inetint} -s ${remoteip} -d ${localip} -j ACCEPT
	  /sbin/iptables -D INPUT  -p 51 -i ${inetint} -s ${remoteip} -d ${localip} -j ACCEPT
	  /sbin/iptables -D INPUT  -p 50 -i ${inetint} -s ${remoteip} -d ${localip} -j ACCEPT
	  /sbin/iptables -D INPUT  -p udp -i ${inetint} -s ${remoteip} --sport 4500 -d ${localip} --dport 4500 -j ACCEPT
	  /sbin/iptables -D INPUT  -p udp -i ${inetint} -s ${remoteip} --sport 500 -d ${localip} --dport 500 -j ACCEPT
	  /sbin/iptables -D OUTPUT  -p 4 -o ${inetint} -d ${remoteip} -s ${localip} -j ACCEPT
	  /sbin/iptables -D OUTPUT  -p 51 -o ${inetint} -d ${remoteip} -s ${localip} -j ACCEPT
	  /sbin/iptables -D OUTPUT  -p 50 -o ${inetint} -d ${remoteip} -s ${localip} -j ACCEPT
	  /sbin/iptables -D OUTPUT  -p udp -o ${inetint} -d ${remoteip} --dport 4500 -s ${localip} --sport 4500 -j ACCEPT
	  /sbin/iptables -D OUTPUT  -p udp -o ${inetint} -d ${remoteip} --dport 500 -s ${localip} --sport 500 -j ACCEPT

	  /sbin/ip route flush cache
	  /sbin/ip link set dev ${tunname} down
	  /bin/sleep 5
	  /sbin/ip tunnel del ${tunname}
	  num=$((num+=1))
      done

      ## GLOBAL Stop StrongSwan daemons
      /usr/sbin/ipsec stop
      /bin/sleep 5
      ;;
  *)
        echo "PakSecured Linux VPN Initialization Script"
	echo "Copyright 1996-2020  Paktronix Systems LLC"
	echo "Contacts:"
	echo "Matthew G. Marsh - mgm@paktronix.com  402-932-7250"
	echo "Usage: $0 {start|stop}"
	exit 1
esac

exit 0
