#!/bin/bash
##
## PakVPN RoadWarrior WG ostiary initialization script
##
## CRE 23jan21 
##

PakRemo=${1}

## Define Globals
NATOUT01=pak23
NATOUT02=pak2
NATIP01="172.18.0.13"
NATIP02="172.18.0.13"
RWIP="172.18.1.1"

echo "Start PakRemoWG VPN - `/bin/date '+%a, %d-%B-%Y at %H:%M'` " >> /opt/pakadmin/PakREMO.log
echo "From $1  and $PakRemo "  >> /opt/pakadmin/PakREMO.log

## Find insertion points for fw rules
fwdis=`/sbin/iptables -L FORWARD -n -v --line-numbers | grep "LOG" | /usr/bin/cut -c1-2 | /usr/bin/tail -1  `
inis=`/sbin/iptables -L INPUT -n -v --line-numbers | grep "DROP" | grep "224.0.0.1" | /usr/bin/cut -c1-2 | /usr/bin/tail -1  `
outis=`/sbin/iptables -L OUTPUT -n -v --line-numbers | grep "ACCEPT" | grep "RELATED" | /usr/bin/cut -c1-2 | /usr/bin/tail -1  `

## Insert INPUT rules for WG
/sbin/iptables -I INPUT ${inis} -i inet -s ${PakRemo} -d 7.6.5.4 -j ACCEPT

## Insert OUTPUT rules for WG
/sbin/iptables -I OUTPUT ${outis} -o inet -d ${PakRemo} -s 7.6.5.4 -j ACCEPT

## Enable NAT for road warrior 
ponatis=`/sbin/iptables -t nat  -L POSTROUTING -n -v --line-numbers | grep "LOG" | /usr/bin/cut -d" " -f1 | /usr/bin/tail -1  `
/sbin/iptables -t nat -I POSTROUTING ${ponatis} -o ${NATOUT01} -s ${RWIP} -j SNAT --to-source ${NATIP01}
/sbin/iptables -t nat -I POSTROUTING ${ponatis} -o ${NATOUT02} -s ${RWIP} -j SNAT --to-source ${NATIP02} 

## Enable PakVPN WG subsystem
/etc/vpn/PakVPN.Master.sh wginsert 0 0

echo "End PakRemo WG Start" >> /opt/pakadmin/PakREMO.log
